App-Staticperl
view release on metacpan or search on metacpan
staticperl.sh view on Meta::CPAN
#!/bin/sh
#############################################################################
# configuration to fill in (or to replace in your .staticperlrc)
STATICPERL=~/.staticperl
CPAN=http://mirror.netcologne.de/cpan # which mirror to use
EMAIL="read the documentation <rtfm@example.org>"
DLCACHE=
# perl build variables
MAKE=make
PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
PERL_CC=cc
PERL_CONFIGURE="" # additional Configure arguments
PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
ARCH="$(uname -m)"
#case "$ARCH" in
# i*86 | x86_64 | amd64 )
# PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
# case "$ARCH" in
# i*86 )
# PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
# ;;
# esac
# ;;
#esac
# -Wl,--gc-sections makes it impossible to check for undefined references
# for some reason so we need to patch away the "-no" after Configure and before make :/
# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
PERL_LDFLAGS=
PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
# some configuration options for modules
PERL_MM_USE_DEFAULT=1
PERL_MM_OPT="MAN1PODS= MAN3PODS="
#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
export PERL_MM_USE_DEFAULT PERL_MM_OPT
# which extra modules to install by default from CPAN that are
# required by mkbundle
STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
# which extra modules you might want to install
EXTRA_MODULES=""
# overridable functions
preconfigure() { : ; }
patchconfig() { : ; }
postconfigure() { : ; }
postbuild() { : ; }
postinstall() { : ; }
# now source user config, if any
if [ "$STATICPERLRC" ]; then
. "$STATICPERLRC"
else
[ -r /etc/staticperlrc ] && . /etc/staticperlrc
[ -r ~/.staticperlrc ] && . ~/.staticperlrc
[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
fi
#############################################################################
# support
# work around ExtUtils::CBuilder and others
export CC="$PERL_CC"
export CFLAGS="$PERL_CFLAGS"
export LD="$PERL_CC"
export LDFLAGS="$PERL_LDFLAGS"
unset LIBS
PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
unset PERL_MB_OPT
LC_ALL=C; export LC_ALL # just to be on the safe side
# prepend PATH - not required by staticperl itself, but might make
# life easier when working in e.g. "staticperl cpan / look"
PATH="$PERL_PREFIX/perl/bin:$PATH"
# set version in a way that Makefile.PL can extract
VERSION=VERSION; eval \
$VERSION="1.46"
fatal() {
printf -- "\nFATAL: %s\n\n" "$*" >&2
exit 1
}
verbose() {
printf -- "%s\n" "$*"
}
verblock() {
staticperl.sh view on Meta::CPAN
configure_failure() {
cat <<EOF
***
*** Configure failed - see above for the exact error message(s).
***
*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
*** flags are not supported by your compiler. Less often, this is because
*** PERL_LIBS either contains a library not available on your system (such as
*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
***
*** You can provide your own flags by creating a ~/.staticperlrc file with
*** variable assignments. For example (these are the actual values used):
***
PERL_CC="$PERL_CC"
PERL_CCFLAGS="$PERL_CCFLAGS"
PERL_OPTIMIZE="$PERL_OPTIMIZE"
PERL_LDFLAGS="$PERL_LDFLAGS"
PERL_LIBS="$PERL_LIBS"
EOF
exit 1
}
configure() {
(
fetch
rcd "$STATICPERL/src/perl"
[ -e staticstamp.configure ] && return
verblock <<EOF
configuring $STATICPERL/src/perl
EOF
rm -f "$PERL_PREFIX/staticstamp.install"
"$MAKE" distclean >/dev/null 2>&1
sedreplace '/^#define SITELIB/d' config_h.SH
# I hate them for this
grep -q -- -fstack-protector Configure && \
sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
# what did that bloke think
grep -q -- usedl=.define hints/darwin.sh && \
sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
preconfigure || fatal "preconfigure hook failed"
# trace configure \
sh Configure -Duselargefiles \
-Uuse64bitint \
-Dusemymalloc=n \
-Uusedl \
-Uusethreads \
-Uuseithreads \
-Uusemultiplicity \
-Uusesfio \
-Uuseshrplib \
-Uinstallusrbinperl \
-A ccflags=" $PERL_CCFLAGS" \
-Dcc="$PERL_CC" \
-Doptimize="$PERL_OPTIMIZE" \
-Dldflags="$PERL_LDFLAGS" \
-Dlibs="$PERL_LIBS" \
-Dprefix="$PERL_PREFIX" \
-Dbin="$PERL_PREFIX/bin" \
-Dprivlib="$PERL_PREFIX/lib" \
-Darchlib="$PERL_PREFIX/lib" \
-Uusevendorprefix \
-Dsitelib="$PERL_PREFIX/lib" \
-Dsitearch="$PERL_PREFIX/lib" \
-Uman1dir \
-Uman3dir \
-Usiteman1dir \
-Usiteman3dir \
-Dpager=/usr/bin/less \
-Demail="$EMAIL" \
-Dcf_email="$EMAIL" \
-Dcf_by="$EMAIL" \
$PERL_CONFIGURE \
-Duseperlio \
-Uversiononly \
-dE || configure_failure
sedreplace '
s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
s/ *-fno-stack-protector */ /g
' config.sh
patchconfig || fatal "patchconfig hook failed"
sh Configure -S || fatal "Configure -S failed"
postconfigure || fatal "postconfigure hook failed"
: > staticstamp.configure
) || exit
}
write_shellscript() {
{
echo "#!/bin/sh"
echo "STATICPERL=\"$STATICPERL\""
echo "PERL_PREFIX=\"$PERL_PREFIX\""
echo "MAKE=\"$MAKE\""
cat
} >"$PERL_PREFIX/bin/$1"
chmod 755 "$PERL_PREFIX/bin/$1"
}
build() {
(
configure
rcd "$STATICPERL/src/perl"
( run in 1.074 second using v1.01-cache-2.11-cpan-39bf76dae61 )